#include "Actor.h"

ActorTemplate::ActorTemplate(Vector size, float speed, float max_health, string name, int flags, Weapon *rweapon, Weapon *lweapon, int ai_level, string class_name, string trigger_message, float damage, float radius)
{
	this->size = size;
	this->speed = speed;
	this->health = this->max_health = max_health;
	this->name = name;
	this->flags = flags;
	this->rweapon = rweapon;
	this->lweapon = lweapon;
	this->ai_level = ai_level;
	this->class_name = class_name;
	this->trigger_message = trigger_message;
	this->damage = damage;
	this->radius = radius;
}

Actor::~Actor()
{
}

Actor::Actor()
{
}

Actor::Actor(Actor &a)
{
	MDLNUMBER = a.MDLNUMBER;
	origin = a.origin;
	angle = a.angle;
	size = a.size;
	camera_view_ofs = a.camera_view_ofs;
	speed = a.speed;
	owner = a.owner;
	other = a.other;
	enemy = a.enemy;
	next = a.next;
	health = a.health;
	max_health = a.max_health;
	frags = a.frags;
	name = a.name;
	team = a.team;
	exp = a.exp;
	level = a.level;
	featPoints = a.featPoints;
	flags = a.flags;
	rweapon = a.rweapon;
	lweapon = a.lweapon;
	ai_level = a.ai_level;
	class_name = a.class_name;
	next_think = a.next_think;
	goal_point = a.goal_point;
	trigger_message = a.trigger_message;
	dam_mod = a.dam_mod;
	move_mod = a.move_mod;
	reload_mod = a.reload_mod;
	fire_mod = a.fire_mod;
	regen_mod = a.regen_mod;
	exp_mod = a.exp_mod;
	ammo_mod = a.ammo_mod;
	hp_mod = a.hp_mod;
	damage = a.damage;
	radius = a.radius;
}

Actor::Actor(ActorTemplate &at)
{
	angle = at.angle;
	size = at.size;
	camera_view_ofs = at.camera_view_ofs;
	speed = at.speed;
	health = at.health;
	max_health = at.max_health;
	name = at.name;
	exp = 0;
	level = 1;
	flags = at.flags;
	rweapon = at.rweapon;
	lweapon = at.lweapon;
	ai_level = at.ai_level;
	class_name = at.class_name;
	next_think = 0;//think asap
	trigger_message = at.trigger_message;
	damage = at.damage;
	radius = at.radius;
}

void Actor::Damage(Actor *p, int Dmg)//this indicats that monsters cant hurt eachother
{
/*	if (p->owner == this) return;
	health = health - ((float)Dmg/hp_mod);
	if (health < 0)
	{
		Die();
		return;
	}
	else
		enemy = p;*/
}

void Actor::Touch(Actor *a)
{
/*	if (flags & AProp_Missile)
		a->Damage(this, (int)damage);

	if (flags & AProp_Item)
		switch(flags & AProp_Effects >> 6)
		{
			case 1://med kit
				a->health += a->health * damage;
				if (a->health > a->max_health) 
					a->health = a->max_health;
				break;
			case 2: a->dam_mod *= damage; break;//damage is actualy just the amount to change it
			case 3: a->move_mod *= damage; break;
			case 4: a->regen_mod *= damage; break;
			case 5: a->fire_mod *= damage; break;
			case 6: a->reload_mod *= damage; break;
			case 7: a->exp_mod *= damage; break;
			case 8: a->ammo_mod *= damage; break;
			case 9: a->hp_mod *= damage; break;
		}//goes from 0 - 15*/
}


void Actor::Die()
{
	speed = 0;
	flags = 0;
	if (enemyType != groundStupid)
		SetNewRanges();
}

void Actor::SetNewRanges()
{
	float origRange, diff;
	float *currRange;

	if (!damageDone)	//if the action wasnt successful, dont update...maybe put in a
		return;			//negative change later

	if (currentAction == kamikaze)
	{
		origRange = kamikazeRange;
		kamikazeRange *= 1.3;
		diff = kamikazeRange - origRange;
		currRange = &kamikazeRange;
	}
	else if (currentAction == survivor)
	{
		origRange = survivorRange;
		survivorRange *= 1.3;
		diff = survivorRange - origRange;	
		currRange = &survivorRange;
	}
	else if (currentAction == groupie)
	{
		origRange = groupieRange;
		groupieRange *= 1.3;
		diff = groupieRange - origRange;	
		currRange = &groupieRange;
	}
	else if (currentAction == convict)
	{
		origRange = convictRange;
		convictRange *= 1.3;
		diff = convictRange - origRange;
		currRange = &convictRange;
	}
	else if (currentAction == dodger)
	{
		origRange = dodgerRange;
		dodgerRange *= 1.3;
		diff = dodgerRange - origRange;	
		currRange = &dodgerRange;
	}
	else if (currentAction == jump)
	{
		origRange = jumpRange;
		jumpRange *= 1.3;
		diff = jumpRange - origRange;
		currRange = &jumpRange;
	}
	else
	{
		origRange = diveBombRange;
		diveBombRange *= 1.3;
		diff = diveBombRange - origRange;	
		currRange = &diveBombRange;
	}
	
	diff /= 7;

	if (currentAction != kamikaze)
	{
		if (kamikazeRange - diff >= 0.5)
			kamikazeRange -= diff;
		else
		{
			*currRange -= (kamikazeRange - 0.5);
			kamikazeRange = 0.5;					
		}
	}
	if (currentAction != survivor)
	{
		if (survivorRange - diff >= 0.5)
			survivorRange -= diff;
		else
		{
			*currRange -= (survivorRange - 0.5);
			survivorRange = 0.5;					
		}
	}
	if (currentAction != groupie)
	{
		if (groupieRange - diff >= 0.5)
			groupieRange -= diff;
		else
		{
			*currRange -= (groupieRange - 0.5);
			groupieRange = 0.5;					
		}
	}
	if (currentAction != convict)
	{
		if (convictRange - diff >= 0.5)
			convictRange -= diff;
		else
		{
			*currRange -= (convictRange - 0.5);
			convictRange = 0.5;					
		}
	}
	if (currentAction != dodger)
	{
		if (dodgerRange - diff >= 0.5)
			dodgerRange -= diff;
		else
		{
			*currRange -= (dodgerRange - 0.5);
			dodgerRange = 0.5;					
		}
	}
	if (currentAction != jump)
	{
		if (jumpRange - diff >= 0.5)
			jumpRange -= diff;
		else
		{
			*currRange -= (jumpRange - 0.5);
			jumpRange = 0.5;					
		}
	}
	if (currentAction != diveBomb && enemyType == flyer)
	{
		if (diveBombRange - diff >= 0.5)
			diveBombRange -= diff;
		else
		{
			*currRange -= (diveBombRange - 0.5);
			diveBombRange = 0.5;					
		}
	}
}
void Actor::Rebirth()
{
	damageDone = false;
	if (enemyType != groundStupid)
		currentAction = GetNewAction();
}

void Actor::CheckHealPoint()
{
	int healXPos = healPoint->xPos;
	int healYPos = healPoint->yPos;
	int healSize = healPoint->size;

	if (health <= 0) 
		return;
	if (origin.x <= (healXPos + healSize) && origin.x >= (healXPos - healSize) &&
		origin.y <= (healYPos + healSize) && origin.y >= (healYPos - healSize))
	{
		atHealPoint = true;
		healCount++;
		if (healCount >= healCap)
		{
			healCount = 0;
			health++;
		}
	}
	else
		atHealPoint = false;
}
void Actor::AI()
{
	if (health <= 0)
		return;
	CheckHealPoint();	

	if (currentAction == kamikaze)
	{
			DoKamikazeAction();
	}
	else if (currentAction == dodger)
	{
			DoDodgerAction();
	}
	else if (currentAction == survivor)
	{
			DoSurvivorAction();
	}
	else if (currentAction == groupie)
	{
			DoGroupieAction();
	}
	else if (currentAction == convict)
	{
			DoConvictAction();
	}
	else if (currentAction == jump)
	{
			DoJumpAction();
	}
	else if (currentAction == diveBomb)
	{
			DoDiveBombAction();
	}
	Attack();

	return;
}


void Actor::Attack()	//attack function also checks if enemy is in range
{
	attackCount++;
	if (attackCount < attackCap)	//only check if it can attack if attack time is up
		return;
	attackCount = 0;

	//big ass if statement to check if the player is in attack range
	if (origin.x <= (playerPos.x + attackRange) && 
		origin.x >= (playerPos.x - attackRange) &&
		origin.y <= (playerPos.y + attackRange) &&
		origin.y >= (playerPos.y - attackRange) &&
		origin.z <= (playerPos.z + attackRange) &&
		origin.z >= (playerPos.z - attackRange))
	{
		*playerHealth -= attackDamage;
		damageDone = true;
	}
}

EnemyAction Actor::GetNewAction()
{
	float kamikazeStart = 0;
	float kamikazeEnd = 0;
	float survivorStart = 0;
	float survivorEnd = 0;
	float groupieStart = 0;
	float groupieEnd = 0; 
	float convictStart = 0, convictEnd = 0; 
	float dodgerStart = 0;
	float dodgerEnd = 0;
	float jumpStart = 0, jumpEnd = 0;
	float diveBombStart =0 , diveBombEnd = 0;
	EnemyAction newAction = kamikaze;

	if (enemyType == groundStupid)
	{
		newAction = kamikaze;
		return newAction;
	}
	else if (enemyType == groundSmart)
	{
		kamikazeStart = 0;
		kamikazeEnd		= kamikazeRange;
		survivorStart	= kamikazeEnd;
		survivorEnd		= survivorStart + survivorRange;
		groupieStart	= survivorEnd;
		groupieEnd		= groupieStart + groupieRange;
		convictStart	= groupieEnd;
		convictEnd		= convictStart + convictRange;
		dodgerStart		= convictEnd; 
		dodgerEnd		= dodgerStart + dodgerRange;
		jumpStart		= dodgerEnd;
		jumpEnd			= jumpStart + jumpRange;
		diveBombStart	= diveBombEnd = 11;
	}
	else if (enemyType == flyer)
	{
		kamikazeStart = 0;
		kamikazeEnd		= kamikazeRange;
		survivorStart	= kamikazeEnd;
		survivorEnd		= survivorStart + survivorRange;
		groupieStart	= survivorEnd;
		groupieEnd		= groupieStart + groupieRange;
		convictStart	= groupieEnd;
		convictEnd		= convictStart + convictRange;
		dodgerStart		= convictEnd; 
		dodgerEnd		= dodgerStart + dodgerRange;
		jumpStart		= dodgerEnd;
		jumpEnd			= jumpStart + jumpRange;
		diveBombStart	= jumpEnd;
		diveBombEnd		= diveBombStart + diveBombRange;
	}

	int randInt = (rand()%10);	//for better results, make a float

	if (randInt >= kamikazeStart && randInt < kamikazeEnd)
		newAction = kamikaze;
	else if (randInt >= survivorStart && randInt < survivorEnd)
		newAction = survivor;
	else if (randInt >= groupieStart && randInt < groupieEnd)
		newAction = groupie;
	else if (randInt >= convictStart && randInt < convictEnd)
		newAction = convict;
	else if (randInt >= dodgerStart && randInt < dodgerEnd)
		newAction = dodger;
	else if (randInt >= jumpStart && randInt < jumpEnd)
		newAction = jump;
	else if (randInt >= diveBombStart && randInt <= diveBombEnd)
		newAction = diveBomb;
	
	if (newAction == nothing && (enemyType == flyer || enemyType == groundSmart))
		newAction = kamikaze;
	
	return newAction;
}
void Actor::DoKamikazeAction()
{
	MoveTo(playerPos.x, playerPos.y, 0);
}

void Actor::DoSurvivorAction()
{
	if (health < maxHealth && !atHealPoint)
		MoveTo(healPoint->xPos, healPoint->yPos, healPoint->zPos);
	else
		MoveTo(playerPos.x, playerPos.y, 0);
}

void Actor::DoDodgerAction()
{
	float xDiff, yDiff;

	dodgeCount++;
	if (dodgeCount >= dodgeCap)
	{
		dodgeOffset *= -1;
		dodgeCount = 0;
	}

	xDiff = abs(playerPos.x - origin.x);
	yDiff = abs(playerPos.y - origin.y);
	if (xDiff < attackArea && xDiff > -attackArea&& yDiff < attackArea&& yDiff > -attackArea)
		DoKamikazeAction();
	else
	{
		if (yDiff > xDiff)
		{
			MoveTo(playerPos.x +  dodgeOffset, playerPos.y, 0);
		}
		else 
		{
			MoveTo(playerPos.x, playerPos.y +  dodgeOffset, 0);
		}
	}
}


void Actor::DoGroupieAction()
{
	DoKamikazeAction();	
}
void Actor::DoConvictAction()
{
	DoDodgerAction();
}
void Actor::DoJumpAction()
{
	jumpCount++;
	if (jumpCount >= jumpCap)
	{		
		jumpCount = 0;
		jumping = true;
		jumpDirection = 1;
	}
	if (jumping)
		EnemyJump();
	DoKamikazeAction();
}
void Actor::EnemyJump()
{
	jumpSpeedCount++;
	if (jumpSpeedCount >= jumpSpeed)
	{
		jumpSpeedCount = 0;
		jumpTime++;
		if (jumpTime > jumpTimeLimit)
		{
			jumpTime = 0;
			jumpDirection *= -1;
			if (jumpDirection == 1)
				jumping = false;
		}		
		jumpOffset += jumpDirection;
	}	
	origin.z += jumpOffset;
}
void Actor::DoDiveBombAction()
{
	//this is just jumping
	DoJumpAction();
}

void Actor::InitEnemy(int i, HealingPoint *_healPoint, Vector _playerPos, float *phealth)
{
	if (i == 1)
		enemyType = groundStupid;
	else if (i == 2)
		enemyType = groundSmart;
	else if (i == 3)
		enemyType = flyer;

	playerPos	= _playerPos;
	healPoint	= _healPoint;
	playerHealth= phealth;
	healCount	= 0;
	healCap		= 30;
	attackArea	= 2;	//all arbitrary values, have to test to find values that work
	dodgeOffset = 50;
	dodgeCount	= 0;
	dodgeCap	= 200;
	jumpCount	= 0;
	jumpCap		= 100;
	attackCount	= 0;
	attackCap	= 30;
	diveBombHeight = 10;
	attackRange	= 3;
	jumpDirection = 1;
	jumpTime = 0;
	jumpTimeLimit = 5;
	jumpOffset = 0;
	lastZ = origin.z;
	jumpSpeed = 5;
	jumpSpeedCount = 0;

	//set the probabilities for each action (out of 10) depending on the type of enemy
	if (enemyType == groundStupid)
	{
		attackDamage  = STUPIDDAMAGE;
		maxHealth     = health;
		currentAction = kamikaze;
		kamikazeRange = 10;
		survivorRange = groupieRange = convictRange = dodgerRange = jumpRange = 
			diveBombRange = 0;
		actionAmount  = 1;
	}
	else if (enemyType == groundSmart)
	{
		attackDamage = SMARTDAMAGE;
		maxHealth = health;
		currentAction = nothing;
		kamikazeRange = 1.7;
		survivorRange = groupieRange = convictRange = dodgerRange = jumpRange = 1.66;
		diveBombRange = 0;
		actionAmount = 6;				
	}
	else if (enemyType == flyer)
	{
		attackDamage = FLYERDAMAGE;
		maxHealth = health;
		currentAction = nothing;
		kamikazeRange = 1.42;
		survivorRange = groupieRange = convictRange = dodgerRange = jumpRange = 
			diveBombRange = 1.43;
		actionAmount = 7;
	}
	currentAction = GetNewAction();	
}

void Actor::MoveTo(float x, float y, float z)
{
	float xvec, yvec, angle;

	xvec = origin.x - x;
	yvec = origin.y - y;
	angle = atan(yvec/xvec);
	angle *= 180/3.142;	//convert to degrees

	xvec = speed * cos(angle);
	yvec = speed * sin(angle);

	origin.x += xvec;
	origin.y += yvec;


/*	float adj;	//movement code for flyers i guess
	adj = speed * cos(angle);
	xDest = (adj * sin(xRotation)) + playerPosX;
	zDest = (adj * cos(xrotation)) + playerPosZ;
	yDest = (-(range * 
		sin(playerRotY))) + playerPosY;*/
}

void Actor::SetPlayerPos(Vector pPos)
{
	playerPos = pPos;
}