#include "Map.h"
#include <fstream>
#include <sstream>
using namespace std;

map::~map()
{
	if (g_pTriangleStrip_VB)
		g_pTriangleStrip_VB->Release();
	for (int i = 0; i < 61; i++)
		if (g_pTriangleStripGroup_VB[i])
			g_pTriangleStripGroup_VB[i]->Release();
}

map::map(LPDIRECT3DDEVICE9 g_pd3dDevice, char* Filename)
{
	ColorLevels[0]  = D3DCOLOR_COLORVALUE(0.0,  0.0,  0.2,  1.0);//Water
	ColorLevels[1]  = D3DCOLOR_COLORVALUE(0.0,  0.0, 0.35,  1.0);
	ColorLevels[2]  = D3DCOLOR_COLORVALUE(0.0,  0.0,  0.5,  1.0);
	ColorLevels[3]  = D3DCOLOR_COLORVALUE(0.0,  0.15,0.65,  1.0);
	ColorLevels[4]  = D3DCOLOR_COLORVALUE(0.0,  0.35, 0.8,  1.0);
	ColorLevels[5]  = D3DCOLOR_COLORVALUE(0.0,  0.5, 0.95,  1.0);
	ColorLevels[6]  = D3DCOLOR_COLORVALUE(0.0,  0.6,  1.0,  1.0);

	ColorLevels[7]  = D3DCOLOR_COLORVALUE(0.0,  0.7,  0.8,  1.0);//Beach
	ColorLevels[8]  = D3DCOLOR_COLORVALUE(0.2,  0.8,  0.6,  1.0);
	ColorLevels[9]  = D3DCOLOR_COLORVALUE(0.4,  0.9,  0.4,  1.0);

	ColorLevels[10] = D3DCOLOR_COLORVALUE(0.6,  1.0,  0.0,  1.0);//Land
	ColorLevels[11] = D3DCOLOR_COLORVALUE(0.5,  0.9,  0.0,  1.0);
	ColorLevels[12] = D3DCOLOR_COLORVALUE(0.4,  1.0,  0.2,  1.0);
	ColorLevels[13] = D3DCOLOR_COLORVALUE(0.3,  0.9,  0.0,  1.0);
	ColorLevels[14] = D3DCOLOR_COLORVALUE(0.2,  1.0,  0.1,  1.0);
	ColorLevels[15] = D3DCOLOR_COLORVALUE(0.2,  1.0,  0.1,  1.0);
	ColorLevels[16] = D3DCOLOR_COLORVALUE(0.0,  1.0,  0.1,  1.0);
	ColorLevels[17] = D3DCOLOR_COLORVALUE(0.1,  0.9,  0.0,  1.0);
	ColorLevels[18] = D3DCOLOR_COLORVALUE(0.1,  1.0,  0.2,  1.0);
	ColorLevels[19] = D3DCOLOR_COLORVALUE(0.3,  0.8,  0.2,  1.0);
	ColorLevels[20] = D3DCOLOR_COLORVALUE(0.0,  1.0,  0.1,  1.0);
	ColorLevels[21] = D3DCOLOR_COLORVALUE(0.2,  0.9,  0.1,  1.0);
	ColorLevels[22] = D3DCOLOR_COLORVALUE(0.3,  0.9,  0.1,  1.0);
	ColorLevels[23] = D3DCOLOR_COLORVALUE(0.2,  1.0,  0.1,  1.0);

	ColorLevels[24] = D3DCOLOR_COLORVALUE(0.35, 0.9,  0.2,  1.0);//Mountains
	ColorLevels[25] = D3DCOLOR_COLORVALUE(0.3,  1.0,  0.3,  1.0);
	ColorLevels[26] = D3DCOLOR_COLORVALUE(0.35, 0.9,  0.4,  1.0);
	ColorLevels[27] = D3DCOLOR_COLORVALUE(0.4,  0.85, 0.5,  1.0);
	ColorLevels[28] = D3DCOLOR_COLORVALUE(0.5,  0.8,  0.65, 1.0);
	ColorLevels[29] = D3DCOLOR_COLORVALUE(0.7,  0.85, 0.85, 1.0);
	ColorLevels[30] = D3DCOLOR_COLORVALUE(0.9,  0.9,  0.9,  1.0);
	ColorLevels[31] = D3DCOLOR_COLORVALUE(0.0,  0.0,  0.0,  0.0);
	ColorLevels[32] = D3DCOLOR_COLORVALUE(0.0,  0.0,  0.0,  0.0);

	ifstream is(Filename);
	if (Filename != 0 && is)
	{
		float temp;
		//Load Data
		for (int i = 0; i < 64; i++)
			for (int j = 0; j < 64; j++) {
				is >> temp;
				heightmap[i][j] = temp;
			}
	}
	else
		for (int i = 0; i < 64; i++)
			for (int j = 0; j < 64; j++)
				heightmap[i][j] = abs((i-32)*(j-32)) / 32;

	for (int i = 0; i < 64; i++)
	{
		heightmap[i][0] = 32;
		heightmap[i][62] = 32;
		heightmap[0][i] = 32;
		heightmap[63][i] = 32;
	}

	HMVertex *pVertices = NULL;
	for (int i = 0; i < 62; i++)
	{
		pVertices = NULL;
		for (int j = 0; j < 128; j++)
		{
			float Z = heightmap[j / 2 % 64][j % 2 + i];

			if (Z > 31) Z = 31;
			g_triangleStrip[j].color = ColorLevels[(int)Z];

			g_triangleStrip[j].x = (float)(j / 2);
			g_triangleStrip[j].y = (float)(j % 2) + i;
			g_triangleStrip[j].z = (float)-Z;
		}

		g_pTriangleStripGroup_VB[i] = NULL;

		g_pd3dDevice->CreateVertexBuffer(128*sizeof(HMVertex), 0, D3D_HEIGHTMAP_FVF_MY_VERTEX, D3DPOOL_DEFAULT, &g_pTriangleStrip_VB, NULL);
		g_pTriangleStripGroup_VB[i] = g_pTriangleStrip_VB;

		g_pTriangleStripGroup_VB[i]->Lock(0, sizeof(g_triangleStrip), (void**)&pVertices, 0);
		memcpy(pVertices, g_triangleStrip, sizeof(g_triangleStrip));
		g_pTriangleStripGroup_VB[i]->Unlock();
	}
}
