#include "Vector.h"
#include "math.h"

Vector::Vector()
{
	x=0.0;y=0.0;z=0.0;
}

Vector::Vector(Vector& v)
:x(v.x),y(v.y),z(v.z)
{}

Vector::Vector(int x, int y, int z)
:x((float)x),y((float)y),z((float)z)
{}

Vector::Vector(float x, float y, float z)
:x(x),y(y),z(z)
{}

Vector& Vector::normailize()
{
	Vector &b = *(new Vector(*this));
	float d = size();
    b.x = b.x / d;
    b.y = b.y / d;
    b.z = b.z / d;
    return b;
}

float Vector::angleize(int t)// 0=xy 1 = xz 2 = zy
{
	float a, b;
	if (t==0) {a=x; b=y;}
	if (t==1) {a=x; b=z;}
	if (t==2) {a=y; b=z;}
	
	return atan2(b, a);
}

float Vector::size(){return sqrt(x * x + y * y + z * z);}

Vector& Vector::operator+(Vector& v)
{
	Vector &b = *(new Vector());
	b.x = x + v.x;
	b.y = y + v.y;
	b.z = z + v.z;
	return b;
}

Vector& Vector::operator-(Vector& v)
{
	Vector &b = *(new Vector());
	b.x = x - v.x;
	b.y = y - v.y;
	b.z = z - v.z;
	return b;
}

Vector& Vector::operator*(Vector& v)//FIXME
{
    float d = (size() + v.size()) / 2;
	Vector &b = *(new Vector());
	b.x = d * v.x;
	b.y = d * v.y;
	b.z = d * v.z;
	return b;
}

Vector& Vector::operator/(Vector& v)//FIXME
{
    float d = (size() + v.size()) / 2;
	Vector &b = *(new Vector());
	b.x = v.x / d;
	b.y = v.y / d;
	b.z = v.z / d;
	return b;
}

Vector& Vector::operator*(float d)
{
	Vector &b = *(new Vector());
	b.x = x * d;
	b.y = y * d;
	b.z = z * d;
	return b;
}

Vector& Vector::operator/(float d)
{
	Vector &b = *(new Vector());
	b.x = x / d;
	b.y = y / d;
	b.z = z / d;
	return b;
}

Vector& Vector::operator=(Vector& v)
{
	x = v.x;
	y = v.y;
	z = v.z;
	return v;
}

bool Vector::operator==(Vector& v){return (v.x == x && v.y == y && v.z == z);}
bool Vector::operator!=(Vector& v){return (v.x != x || v.y != y || v.z != z);}
bool Vector::operator<(Vector& v){return size() < v.size();}
bool Vector::operator<=(Vector& v){return size() <= v.size();}
bool Vector::operator>(Vector& v){return size() > v.size();}
bool Vector::operator>=(Vector& v){return size() >= v.size();}
