#ifndef VECTOR_H
#define VECTOR_H

class Vector
{
    public:
	float x,y,z;
	Vector();
	Vector(Vector& v);
	Vector(int x, int y, int z);
	Vector(float x, float y, float z);
	
	Vector& normailize();
	float angleize(int t);
	float size();
	Vector& operator+(Vector& v);
	Vector& operator-(Vector& v);
	Vector& operator*(Vector& v);
	Vector& operator/(Vector& v);
	Vector& operator*(float d);
	Vector& operator/(float d);
	Vector& operator=(Vector& v);
	
    bool operator==(Vector& v);
	bool operator>(Vector& v);
	bool operator<(Vector& v);
	bool operator!=(Vector& v);
	bool operator>=(Vector& v);
	bool operator<=(Vector& v);
};
#endif