//-----------------------------------------------------------------------------
//           Name: Main.cpp
//         Author: Brian Hume
//    Description: The main file it has rendering too
//        Version: 24.0
//-----------------------------------------------------------------------------


//player death sound, ai, networking, shrink robot, level ups, gameplay, menu

#define STRICT
#define WIN32_LEAN_AND_MEAN

#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include <mmsystem.h>
#include <d3d9.h>
#include <d3dx9.h>
#include <iostream>
#include "resource.h"
#include "Map.h"
#include "Actor.h"
#include "Sound.h"
using namespace std;

#define getRandomMinMax Rnd

map *M;

//-----------------------------------------------------------------------------
// GLOBALS
//-----------------------------------------------------------------------------
HWND                    g_hWnd           = NULL;
LPDIRECT3D9             g_pD3D           = NULL;
LPDIRECT3DDEVICE9       g_pd3dDevice     = NULL;
LPDIRECT3DVERTEXBUFFER9 g_pVertexBuffer  = NULL;
LPD3DXMESH              g_pMesh[4];
D3DMATERIAL9           *g_pMeshMaterials = NULL;
LPDIRECT3DTEXTURE9     *g_pMeshTextures  = NULL;
unsigned long           g_dwNumMaterials = 0L;
LPDIRECT3DTEXTURE9      g_pTexture[16];
LPD3DXFONT				g_pd3dxFont  = NULL;
LPD3DXFONT				g_pd3dxHFont  = NULL;

POINT  g_ptLastMousePosit;
POINT  g_ptCurrentMousePosit;
bool   g_bMousing = false;
float  g_fMoveSpeed = 3.0f;
float  g_fElpasedTime;
float g_dCurTime;
float g_dLastTime;
float g_dStartTime;

float f_JumpHeight = 2.0f;
bool b_JumpUp = false;
bool b_Landed = true;
float d_stdUnitScale = 1;
double gameTime;

float d_NetUpdate = 20;
float d_LastPacket = 0;
bool b_MultiPlayer = false;
double FrameCnt = 0.0f;

D3DXVECTOR3	g_vEye(5.0f, 5.0f, -5.0f);    // Eye Position
D3DXVECTOR3	g_vLook(-0.5f, -0.5f, 0.5f);  // Look Vector
D3DXVECTOR3	g_vUp(0.0f, 1.0f, 0.0f);      // Up Vector
D3DXVECTOR3	g_vRight(1.0f, 0.0f, 0.0f);   // Right Vector

HealingPoint *healPoint = new HealingPoint(30, 30, 0, 3);

struct Vertex
{
    float x, y, z;
    DWORD color;

    enum FVF
	{
		FVF_Flags = D3DFVF_XYZ | D3DFVF_DIFFUSE
	};
};

Vertex g_lineVertices[] =
{
	{ 0.0f, 0.0f, 0.0f,  0xffff0000 }, // red = +x Axis
	{ 5.0f, 0.0f, 0.0f,  0xffff0000 },
	{ 0.0f, 0.0f, 0.0f,  0xff00ff00 }, // green = +y Axis
	{ 0.0f, 5.0f, 0.0f,  0xff00ff00 },
	{ 0.0f, 0.0f, 5.0f,  0xff0000ff }, // blue = +z Axis
	{ 0.0f, 0.0f, 0.0f,  0xff0000ff }
};

DWORD d_currentScreen = 2;
DWORD d_menuSelection = 1;
//-----------------------------------------------------------------------------
// Intro Graphic stuff
//-----------------------------------------------------------------------------
#define D3DFVF_TITLEMAPVERTEX ( D3DFVF_XYZ | D3DFVF_TEX1 )

struct TMVertex
{
	float x, y, z;
	float tu, tv;
};

TMVertex tmvlist[] =
{
	{-1.33f, 1.0f, -1.6f,  0.0f,0.0f },
	{ 1.33f, 1.0f, -1.6f,  1.0f,0.0f },
	{-1.33f,-1.0f, -1.6f,  0.0f,1.0f },
	{ 1.33f,-1.0f, -1.6f,  1.0f,1.0f }
};
//-----------------------------------------------------------------------------
// PARTICAL STUFF
//-----------------------------------------------------------------------------
struct PVertex
{
    D3DXVECTOR3 posit;
    D3DCOLOR    color;

	enum FVF
	{
		FVF_Flags = D3DFVF_XYZ|D3DFVF_DIFFUSE
	};
};

struct Particle
{
    D3DXVECTOR3 m_vCurPos;
    D3DXVECTOR3 m_vCurVel;
	D3DCOLOR    m_vColor;
	DWORD		f_DieTime;
	float		f_Damage;
	bool		b_Alive;
};

const int MAX_PARTICLES = 100;
Particle g_particles[MAX_PARTICLES];

inline DWORD FtoDW( FLOAT f ) { return *((DWORD*)&f); }

//-----------------------------------------------------------------------------
//Actors
//-----------------------------------------------------------------------------
const int MAX_ACTORS = 50;
Actor *Alist[MAX_ACTORS];

const int MAX_MISSILES = 60;
Particle g_particle_Missile[MAX_MISSILES];

Particle g_particle_Net_Missile[3][MAX_MISSILES];

Particle g_particle_Missile_Enemy[MAX_MISSILES];

Actor *Player = new Actor();
Actor EnemyPlayers[3];

//-----------------------------------------------------------------------------
// PLAYER STUFF
//-----------------------------------------------------------------------------
float hp = 100, Max_hp = 100;
float score = 0;
float ammo = 25, Max_ammo = 25;
float level = 1;
float gun = 1, Max_gun = 1;
float loadRate = 4;
bool clipLoad = false;
int MapLev = 0;
//-----------------------------------------------------------------------------
// PROTOTYPES
//-----------------------------------------------------------------------------
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, 
				   LPSTR lpCmdLine, int nCmdShow);
LRESULT CALLBACK WindowProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
void init(void);
void shutDown(void);
void render(void);
void getRealTimeUserInput(void);
void updateViewMatrix(void);
float GetExactHeight(float _Map[64][64], float x, float y);
void menu(void);
void PauseGame(char*);

void Network(void);

void initPointSprites(void);
void updatePointSprites(void);
void renderPointSprites(void);
float getRandomMinMax(float fMin, float fMax);
D3DXVECTOR3 getRandomVector(void);
void NewGame( void );

//------------------------PLACE ME
float getRandomMinMax( float fMin, float fMax )
{
    float fRandNum = (float)rand () / RAND_MAX;
    return fMin + (fMax - fMin) * fRandNum;
}

D3DXVECTOR3 getRandomVector( void )
{
	D3DXVECTOR3 vVector;

    // Pick a random Z between -1.0f and 1.0f.
    vVector.z = getRandomMinMax( -1.0f, 1.0f );
    
    // Get radius of this circle
    float radius = (float)sqrt(1 - vVector.z * vVector.z);
    
    // Pick a random point on a circle.
    float t = getRandomMinMax( -D3DX_PI, D3DX_PI );

    // Compute matching X and Y for our Z.
    vVector.x = (float)cosf(t) * radius;
    vVector.y = (float)sinf(t) * radius;

	return vVector;
}
void initPointSprites( void )
{
	//
	// Load up the point sprite's texture...
	//

	D3DXCreateTextureFromFile( g_pd3dDevice, "IMG\\particle.bmp", &g_pTexture[0] );
	D3DXCreateTextureFromFile( g_pd3dDevice, "IMG\\particle2.bmp", &g_pTexture[1] );

	g_pd3dDevice->SetSamplerState(0, D3DSAMP_MINFILTER, D3DTEXF_LINEAR);
	g_pd3dDevice->SetSamplerState(0, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR);

	//
	// Create a vertex bufer which can be used with point sprites...
	//

    g_pd3dDevice->CreateVertexBuffer( 2048 * sizeof(PVertex), 
                                      D3DUSAGE_DYNAMIC | D3DUSAGE_WRITEONLY | D3DUSAGE_POINTS, 
									  PVertex::FVF_Flags, D3DPOOL_DEFAULT, 
									  &g_pVertexBuffer, NULL );

	//
    // If you want to know the max size that a point sprite can be set to, 
	// and whether or not you can change the size of point sprites in hardware 
	// by sending D3DFVF_PSIZE with the FVF, do this.
	//

	float fMaxPointSize = 0.0f;
	bool  bDeviceSupportsPSIZE = false;
	
    D3DCAPS9 d3dCaps;
    g_pd3dDevice->GetDeviceCaps( &d3dCaps );

    fMaxPointSize = d3dCaps.MaxPointSize;

    if( d3dCaps.FVFCaps & D3DFVFCAPS_PSIZE )
        bDeviceSupportsPSIZE = true;
    else
        bDeviceSupportsPSIZE = false;

	//
	// Initialize our particles so they'll start at the origin with some 
	// random direction and color.
	//

	for( int i = 0; i < MAX_PARTICLES; ++i )
    {
		g_particles[i].m_vCurPos = D3DXVECTOR3(getRandomMinMax( -10.0f, 72.0f ),getRandomMinMax( -10.0f, 72.0f ), -36.0f);
		g_particles[i].m_vCurVel = getRandomVector() * getRandomMinMax( 0.5f, 5.0f );
		g_particles[i].m_vColor = D3DCOLOR_COLORVALUE( getRandomMinMax(0.0f,1.0f), getRandomMinMax(0.0f,1.0f), getRandomMinMax(0.0f,1.0f), 1.0f );
	}
	for( int i = 0; i < MAX_MISSILES; ++i )
    {
		g_particle_Missile[i].m_vCurPos = D3DXVECTOR3(0,0,0);
		g_particle_Missile[i].m_vCurVel = D3DXVECTOR3(0,0,0);
		g_particle_Missile[i].m_vColor = D3DCOLOR_COLORVALUE( 1, 1, 1, 1.0f );
		g_particle_Missile_Enemy[i].m_vCurPos = D3DXVECTOR3(0,0,0);
		g_particle_Missile_Enemy[i].m_vCurVel = D3DXVECTOR3(0,0,0);
		g_particle_Missile_Enemy[i].m_vColor = D3DCOLOR_COLORVALUE( 1, 1, 1, 1.0f );
	}
}
void updatePointSprites( void )
{
	//
	// To repeat the sample automatically, keep track of the overall app time.
	//

	static float dStartAppTime = timeGetTime();
	float fElpasedAppTime = (float)((timeGetTime() - dStartAppTime) * 0.001);

	//
	// To move the particles via their velocity, keep track of how much time  
	// has elapsed since last frame update...
	//

	static float dLastFrameTime = timeGetTime();
	float dCurrenFrameTime = timeGetTime();
	float dElpasedFrameTime = (float)((dCurrenFrameTime - dLastFrameTime) * 0.001);
	dLastFrameTime = dCurrenFrameTime;
	
	//
	// After 5 seconds, repeat the sample by returning all the particles 
	// back to the origin.
	//

    if( fElpasedAppTime >= 0.1f )
	{
		g_particles[rand() % MAX_PARTICLES].m_vCurPos = D3DXVECTOR3(getRandomMinMax( -10.0f, 72.0f ),getRandomMinMax( -10.0f, 72.0f ), -36.0f);
		dStartAppTime = timeGetTime();
	}

	//
	// Move each particle via its velocity and elapsed frame time.
	//
	
	for( int i = 0; i < MAX_PARTICLES; ++i )
	{
		g_particles[i].m_vCurPos += g_particles[i].m_vCurVel * (float)dElpasedFrameTime * 10.0;
		if (g_particles[i].m_vCurPos.x < -10.0) g_particles[i].m_vCurVel.x = -g_particles[i].m_vCurVel.x;
		else if (g_particles[i].m_vCurPos.x > 72.0) g_particles[i].m_vCurVel.x = -g_particles[i].m_vCurVel.x;

		if (g_particles[i].m_vCurPos.y < -10.0) g_particles[i].m_vCurVel.y = -g_particles[i].m_vCurVel.y;
		else if (g_particles[i].m_vCurPos.y > 72.0) g_particles[i].m_vCurVel.y = -g_particles[i].m_vCurVel.y;

		if (g_particles[i].m_vCurPos.z < -40.0) g_particles[i].m_vCurVel.z = -g_particles[i].m_vCurVel.z;
		else if (g_particles[i].m_vCurPos.z > -32.0) g_particles[i].m_vCurVel.z = -g_particles[i].m_vCurVel.z;
	}

	D3DXVECTOR3 v = D3DXVECTOR3(0,0,0);
	for( int i = 0; i < MAX_MISSILES; ++i )
	{
		if (g_particle_Missile_Enemy[i].m_vCurPos != v)
			g_particle_Missile_Enemy[i].m_vCurPos += g_particle_Missile_Enemy[i].m_vCurVel * (float)dElpasedFrameTime * 2.5;

		if (g_particle_Missile[i].m_vCurPos != v)
			g_particle_Missile[i].m_vCurPos += g_particle_Missile[i].m_vCurVel * (float)dElpasedFrameTime * 5.0;
	}
}

void renderPointSprites( void )
{
	//
	// Setting D3DRS_ZWRITEENABLE to FALSE makes the Z-Buffer read-only, which 
	// helps remove graphical artifacts generated from  rendering a list of 
	// particles that haven't been sorted by distance to the eye.
	//
    // Setting D3DRS_ALPHABLENDENABLE to TRUE allows particles, which overlap, 
	// to alpha blend with each other correctly.
	//

    g_pd3dDevice->SetRenderState( D3DRS_ZWRITEENABLE, FALSE );

    g_pd3dDevice->SetRenderState( D3DRS_ALPHABLENDENABLE, TRUE );
    g_pd3dDevice->SetRenderState( D3DRS_DESTBLEND, D3DBLEND_ONE );

	//
	// Set up the render states for using point sprites...
	//

    g_pd3dDevice->SetRenderState( D3DRS_POINTSPRITEENABLE, TRUE );    // Turn on point sprites
    g_pd3dDevice->SetRenderState( D3DRS_POINTSCALEENABLE,  TRUE );    // Allow sprites to be scaled with distance
    g_pd3dDevice->SetRenderState( D3DRS_POINTSIZE,     FtoDW(1.0) );  // Float value that specifies the size to use for point size computation in cases where point size is not specified for each vertex.
    g_pd3dDevice->SetRenderState( D3DRS_POINTSIZE_MIN, FtoDW(1.0f) ); // Float value that specifies the minimum size of point primitives. Point primitives are clamped to this size during rendering. 
    g_pd3dDevice->SetRenderState( D3DRS_POINTSCALE_A,  FtoDW(0.0f) ); // Default 1.0
    g_pd3dDevice->SetRenderState( D3DRS_POINTSCALE_B,  FtoDW(0.0f) ); // Default 0.0
    g_pd3dDevice->SetRenderState( D3DRS_POINTSCALE_C,  FtoDW(1.0f) ); // Default 0.0

	//
	// Lock the vertex buffer, and set up our point sprites in accordance with 
	// our particles that we're keeping track of in our application.
	//

	g_pd3dDevice->SetTexture( 0, g_pTexture[0] );
	PVertex *pPointVertices;

	g_pVertexBuffer->Lock( 0, MAX_PARTICLES * sizeof(PVertex),
		                   (void**)&pPointVertices, D3DLOCK_DISCARD );

	for( int i = 0; i < MAX_PARTICLES; ++i )
    {
        pPointVertices->posit = g_particles[i].m_vCurPos;
        pPointVertices->color = g_particles[i].m_vColor;
        pPointVertices++;
    }

    g_pVertexBuffer->Unlock();
	
	//
	// Render point sprites...
	//

    g_pd3dDevice->SetStreamSource( 0, g_pVertexBuffer, 0, sizeof(PVertex) );
    g_pd3dDevice->SetFVF( PVertex::FVF_Flags );
	g_pd3dDevice->DrawPrimitive( D3DPT_POINTLIST, 0, MAX_PARTICLES );

	//-----MISSILES------------------

	g_pd3dDevice->SetTexture( 0, g_pTexture[1] );
	PVertex *pPointVertices2;

	g_pVertexBuffer->Lock( 0, MAX_MISSILES * sizeof(PVertex),
		                   (void**)&pPointVertices2, D3DLOCK_DISCARD );

	for( int i = 0; i < MAX_MISSILES; ++i )
    {
        pPointVertices2->posit = g_particle_Missile[i].m_vCurPos;
        pPointVertices2->color = g_particle_Missile[i].m_vColor;
        pPointVertices2++;
    }

    g_pVertexBuffer->Unlock();
	
	//
	// Render point sprites...
	//

    g_pd3dDevice->SetStreamSource( 0, g_pVertexBuffer, 0, sizeof(PVertex) );
    g_pd3dDevice->SetFVF( PVertex::FVF_Flags );
	g_pd3dDevice->DrawPrimitive( D3DPT_POINTLIST, 0, MAX_MISSILES );

	//-----EnemyMISSILES------------------

	g_pd3dDevice->SetTexture( 0, g_pTexture[1] );

	g_pVertexBuffer->Lock( 0, MAX_MISSILES * sizeof(PVertex),
		                   (void**)&pPointVertices2, D3DLOCK_DISCARD );

	for( int i = 0; i < MAX_MISSILES; ++i )
    {
        pPointVertices2->posit = g_particle_Missile_Enemy[i].m_vCurPos;
        pPointVertices2->color = g_particle_Missile_Enemy[i].m_vColor;
        pPointVertices2++;
    }

    g_pVertexBuffer->Unlock();
	
	//
	// Render point sprites...
	//

    g_pd3dDevice->SetStreamSource( 0, g_pVertexBuffer, 0, sizeof(PVertex) );
    g_pd3dDevice->SetFVF( PVertex::FVF_Flags );
	g_pd3dDevice->DrawPrimitive( D3DPT_POINTLIST, 0, MAX_MISSILES );

	//
    // Reset render states...
	//	
	
    g_pd3dDevice->SetRenderState( D3DRS_POINTSPRITEENABLE, FALSE );
    g_pd3dDevice->SetRenderState( D3DRS_POINTSCALEENABLE,  FALSE );

    g_pd3dDevice->SetRenderState( D3DRS_ZWRITEENABLE, TRUE );
    g_pd3dDevice->SetRenderState( D3DRS_ALPHABLENDENABLE, FALSE );
}

int initSound(void)
{
	if(FAILED(DirectSoundCreate8(NULL, &g_pDS, NULL))) {
		MessageBox(NULL, "Unable to create DirectSound object", "Error", MB_OK);
		return E_FAIL;
	}
	g_pDS->SetCooperativeLevel(g_hWnd, DSSCL_NORMAL);
	LoadMusic();
	return 0;
}

//-----------------------------------------------------------------------------
// Name: WinMain()
// Desc: The application's entry point
//-----------------------------------------------------------------------------
int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPSTR     lpCmdLine,
					int       nCmdShow )
{
	WNDCLASSEX winClass; 
	MSG        uMsg;

    memset(&uMsg,0,sizeof(uMsg));

	winClass.lpszClassName = "MY_WINDOWS_CLASS";
	winClass.cbSize        = sizeof(WNDCLASSEX);
	winClass.style         = CS_HREDRAW | CS_VREDRAW;
	winClass.lpfnWndProc   = WindowProc;
	winClass.hInstance     = hInstance;
	winClass.hIcon	       = LoadIcon(hInstance, (LPCTSTR)IDI_DIRECTX_ICON);
    winClass.hIconSm	   = LoadIcon(hInstance, (LPCTSTR)IDI_DIRECTX_ICON);
	winClass.hCursor       = LoadCursor(NULL, IDC_ARROW);
	winClass.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
	winClass.lpszMenuName  = NULL;
	winClass.cbClsExtra    = 0;
	winClass.cbWndExtra    = 0;

	if( !RegisterClassEx(&winClass) )
		return E_FAIL;

	g_hWnd = CreateWindowEx( NULL, "MY_WINDOWS_CLASS", 
                             "Direct3D (DX9) - View Matrix",
						     WS_OVERLAPPEDWINDOW | WS_VISIBLE,
					         0, 0, 640, 480, NULL, NULL, hInstance, NULL );

	if( g_hWnd == NULL )
		return E_FAIL;

    ShowWindow( g_hWnd, nCmdShow );
    UpdateWindow( g_hWnd );

	init();
    initPointSprites();
	if (initSound()) return 0;

	render();

	g_dStartTime = timeGetTime();
	while( uMsg.message != WM_QUIT )
	{
		if( PeekMessage( &uMsg, NULL, 0, 0, PM_REMOVE ) )
		{
			TranslateMessage( &uMsg );
			DispatchMessage( &uMsg );
		}
		else
		{
			g_dCurTime     = timeGetTime();
			g_fElpasedTime = (float)((g_dCurTime - g_dLastTime) * 0.001);
			g_dLastTime    = g_dCurTime;
			FrameCnt++;

			if (hp < 0)
				PauseGame("You DIED!!!");
			else if (d_currentScreen == 0)
				render();
			else if (d_currentScreen == 1)
				PauseGame("Game Pause");
			else if (d_currentScreen == 2)	
				menu();
			else if (d_currentScreen == 3)
				PauseGame("Stage Complete");

		}
	}

	shutDown();

    UnregisterClass( "MY_WINDOWS_CLASS", winClass.hInstance );

	return uMsg.wParam;
}

//-----------------------------------------------------------------------------
// Name: WindowProc()
// Desc: The window's message handler
//-----------------------------------------------------------------------------
LRESULT CALLBACK WindowProc( HWND   hWnd, 
							 UINT   msg, 
							 WPARAM wParam, 
							 LPARAM lParam )
{
    switch( msg )
	{
        case WM_LBUTTONDOWN:
		{
			static __int64 bb=0;

			clipLoad = false;

			if (gun == 1.0 && ammo > 0)
			{
				if (snd) {shot->Stop();shot->Play(0,0,0);}
				bb = (bb+1) % (MAX_MISSILES-2);
				g_particle_Missile[bb].m_vCurPos = D3DXVECTOR3(Player->origin.x, Player->origin.y, -Player->origin.z);
				g_particle_Missile[bb].m_vCurVel = D3DXVECTOR3(-g_vRight.z, g_vRight.x, -(g_vLook.y)) * 10;
				g_particle_Missile[bb].m_vCurPos = g_particle_Missile[bb].m_vCurPos + g_particle_Missile[bb].m_vCurVel/10;
				g_particle_Missile[bb].m_vColor = D3DCOLOR_COLORVALUE( 1, 1, 1, 1 );
				g_particle_Missile[bb].b_Alive = true;
				g_particle_Missile[bb].f_DieTime = 0x8fffffff;
				g_particle_Missile[bb].f_Damage = 2.0;
				ammo = ammo - 1;
			}
			else if (gun == 2.0 && ammo > 2)
			{
				if (snd) {shot->Stop();shot2->Play(0,0,0);}
				for (int j = 0; j < 3; j++)
				{
					bb = (bb+1) % (MAX_MISSILES-2);
					g_particle_Missile[bb].m_vCurPos = D3DXVECTOR3(Player->origin.x, Player->origin.y, -Player->origin.z);
					g_particle_Missile[bb].m_vCurVel = D3DXVECTOR3(-g_vRight.z + (j-1)*0.1, g_vRight.x, -(g_vLook.y)) * 10;
					g_particle_Missile[bb].m_vCurPos = g_particle_Missile[bb].m_vCurPos + g_particle_Missile[bb].m_vCurVel/10;
					g_particle_Missile[bb].m_vColor = D3DCOLOR_COLORVALUE( 0, 0, 1, 1 );
					g_particle_Missile[bb].b_Alive = true;
					g_particle_Missile[bb].f_DieTime = 0x8fffffff;
					g_particle_Missile[bb].f_Damage = 1.75;
				}
				ammo = ammo - 3;
			}
			else if (gun == 3.0 && ammo > 3)
			{
				if (snd) {shot->Stop();shot3->Play(0,0,0);}
				for (int j = 0; j < 5; j++)
				{
					bb = (bb+1) % (MAX_MISSILES-2);
					g_particle_Missile[bb].m_vCurPos = D3DXVECTOR3(Player->origin.x, Player->origin.y, -Player->origin.z);
					g_particle_Missile[bb].m_vCurVel = D3DXVECTOR3(-g_vRight.z, g_vRight.x, -(g_vLook.y)) * 10;
					g_particle_Missile[bb].m_vCurPos = g_particle_Missile[bb].m_vCurPos + j * 0.2 * g_particle_Missile[bb].m_vCurVel/10;
					g_particle_Missile[bb].m_vColor = D3DCOLOR_COLORVALUE( 1, 0, 0, 1 );
					g_particle_Missile[bb].b_Alive = true;
					g_particle_Missile[bb].f_DieTime = 0x8fffffff;
					g_particle_Missile[bb].f_Damage = 1.5;
				}
				ammo = ammo - 4;
			}
			else if (gun == 4.0 && ammo > 7)
			{
				if (snd) {shot->Stop();shot4->Play(0,0,0);}
				for (int j = 0; j < 15; j++)
				{
					bb = (bb+1) % (MAX_MISSILES-2);
					g_particle_Missile[bb].m_vCurPos = D3DXVECTOR3(Player->origin.x, Player->origin.y, -Player->origin.z);
					g_particle_Missile[bb].m_vCurVel = D3DXVECTOR3(-g_vRight.z + Rnd(-0.1,0.1), g_vRight.x + Rnd(-0.2,0.2), -(g_vLook.y) + Rnd(-0.1,0.1)) * 10;
					g_particle_Missile[bb].m_vCurPos = g_particle_Missile[bb].m_vCurPos + g_particle_Missile[bb].m_vCurVel/10;
					g_particle_Missile[bb].m_vColor = D3DCOLOR_COLORVALUE( .5, 1, .5, 1 );
					g_particle_Missile[bb].b_Alive = true;
					g_particle_Missile[bb].f_DieTime = 0x8fffffff;
					g_particle_Missile[bb].f_Damage = 1.5;
				}
				ammo = ammo - 8;
			}
			else if (gun == 5.0 && ammo > 9)
			{
				if (snd) {shot->Stop();shot4->Play(0,0,0);}
				for (int j = 0; j < 15; j++)
				{
					bb = (bb+1) % (MAX_MISSILES-2);
					g_particle_Missile[bb].m_vCurPos = D3DXVECTOR3(Player->origin.x, Player->origin.y, -Player->origin.z);
					g_particle_Missile[bb].m_vCurVel = D3DXVECTOR3(-g_vRight.z + Rnd(-0.1,0.1), g_vRight.x + Rnd(-0.2,0.2), -(g_vLook.y) + Rnd(-0.1,0.1)) * 10;
					g_particle_Missile[bb].m_vCurPos = g_particle_Missile[bb].m_vCurPos + g_particle_Missile[bb].m_vCurVel/10;
					g_particle_Missile[bb].m_vColor = D3DCOLOR_COLORVALUE(Rnd(0,1), 0, 0, 1 );
					g_particle_Missile[bb].b_Alive = true;
					g_particle_Missile[bb].f_DieTime = 0x8fffffff;
					g_particle_Missile[bb].f_Damage = 9999;
				}
				ammo = ammo - 10;
			}
			g_bMousing = true;
		}
		break;

		case WM_LBUTTONUP:
		{
			g_bMousing = false;
		}
		break;

		case WM_MOUSEMOVE:
		{

		}
		break;

		case WM_CLOSE:
		{
			PostQuitMessage(0);	
		}
		
        case WM_DESTROY:
		{
            PostQuitMessage(0);
		}
        break;

		default:
		{
			return DefWindowProc( hWnd, msg, wParam, lParam );
		}
		break;
	}

	return 0;
}

//-----------------------------------------------------------------------------
// Name: getRealTimeUserInput()
// Desc: 
//-----------------------------------------------------------------------------
void getRealTimeUserInput( void )
{
	//
	// Get mouse input...
	//

	POINT mousePosit;
	GetCursorPos( &mousePosit );
	ScreenToClient( g_hWnd, &mousePosit );

    g_ptCurrentMousePosit.x = mousePosit.x;
    g_ptCurrentMousePosit.y = mousePosit.y;

	D3DXMATRIX matRotation;

    if( g_bMousing )
    {
		int nXDiff = (g_ptCurrentMousePosit.x - g_ptLastMousePosit.x);
        int nYDiff = (g_ptCurrentMousePosit.y - g_ptLastMousePosit.y);
        
        if( nYDiff != 0 )
		{
			D3DXMatrixRotationAxis( &matRotation, &g_vRight, D3DXToRadian((float)nYDiff / 3.0f));
			D3DXVec3TransformCoord( &g_vLook, &g_vLook, &matRotation );
			D3DXVec3TransformCoord( &g_vUp, &g_vUp, &matRotation );
		}

		if( nXDiff != 0 )
		{
			D3DXMatrixRotationAxis( &matRotation, &D3DXVECTOR3(0,1,0), D3DXToRadian((float)nXDiff / 3.0f) );
			D3DXVec3TransformCoord( &g_vLook, &g_vLook, &matRotation );
			D3DXVec3TransformCoord( &g_vUp, &g_vUp, &matRotation );
		}
    }

    g_ptLastMousePosit.x = g_ptCurrentMousePosit.x;
    g_ptLastMousePosit.y = g_ptCurrentMousePosit.y;

	g_bMousing = true;
	if (g_ptCurrentMousePosit.x > 600 || g_ptCurrentMousePosit.x < 40 || g_ptCurrentMousePosit.y > 440 || g_ptCurrentMousePosit.y < 40)
	{
		g_bMousing = false;
		SetCursorPos( 320, 200 );
	}

	//
	// Get keyboard input...
	//

	unsigned char keys[256];
	GetKeyboardState( keys );
    
    D3DXVECTOR3 tmpLook  = g_vLook;
	D3DXVECTOR3 tmpRight = g_vRight;

	D3DXVECTOR3 B_g_vEye = g_vEye;

	if( keys[VK_ESCAPE] & 0x80 ) d_currentScreen = 2;

	if( keys[VK_PAUSE] & 0x80 ) d_currentScreen = 1;

	if( keys[VK_SHIFT] & 0x80 ) g_fMoveSpeed = 1.0f;
	else g_fMoveSpeed = 5.0f;

	// Up Arrow Key - View moves forward
	if( keys[VK_UP] & 0x80 || keys['W'] & 0x80 )
		g_vEye -= tmpLook*-g_fMoveSpeed*g_fElpasedTime;

	// Down Arrow Key - View moves backward
	if( keys[VK_DOWN] & 0x80 || keys['S'] & 0x80 )
		g_vEye += (tmpLook*-g_fMoveSpeed)*g_fElpasedTime;

	// Left Arrow Key - View side-steps or strafes to the left
	if( keys[VK_LEFT] & 0x80 || keys['A'] & 0x80 )
		g_vEye -= (tmpRight*g_fMoveSpeed)*g_fElpasedTime;

	// Right Arrow Key - View side-steps or strafes to the right
	if( keys[VK_RIGHT] & 0x80 || keys['D'] & 0x80 )
		g_vEye += (tmpRight*g_fMoveSpeed)*g_fElpasedTime;

	//---------------------------------
	// Weapons
	if( keys['1'] & 0x80 && Max_gun >= 1.0 )
		gun = 1.0;
	if( keys['2'] & 0x80 && Max_gun >= 2.0 )
		gun = 2.0;
	if( keys['3'] & 0x80 && Max_gun >= 3.0 )
		gun = 3.0;
	if( keys['4'] & 0x80 && Max_gun >= 4.0 )
		gun = 4.0;
	if( keys['5'] & 0x80 && Max_gun >= 5.0 )
		gun = 5.0;
	//---------------------------------
	// JUMPING

	if( keys[VK_END] & 0x80 || keys['R'] & 0x80 )
		clipLoad = true;

	if( !(keys[VK_SPACE] & 0x80) && !b_JumpUp && f_JumpHeight < 2.01f)
		b_Landed = true;

	if( keys[VK_SPACE] & 0x80 && b_Landed)
	{
		b_JumpUp = true;
		b_Landed = false;
	}
	
	if (b_JumpUp)
	{
		f_JumpHeight = f_JumpHeight * 1.00625f;
		if (f_JumpHeight >= 4.0f) b_JumpUp = false;
	}
	else
		if (f_JumpHeight > 2.0f)
			f_JumpHeight = f_JumpHeight * 0.99375f;
		else if (f_JumpHeight < 2.0f)
			f_JumpHeight = 2.0f;
	//---------------------------------

	if (g_vEye.z >= 60.9f) g_vEye.z = 60.9f;
	if (g_vEye.z <= 0.9f) g_vEye.z = 0.9f;
	if (g_vEye.x >= 61.9f) g_vEye.x = 61.9f;
	if (g_vEye.x <= 0.9f) g_vEye.x = 0.9f;

	float h1 = GetExactHeight(M->heightmap, B_g_vEye.x, B_g_vEye.z);
	float h2 = GetExactHeight(M->heightmap, g_vEye.x, g_vEye.z);

	if (h1 + 8.0*g_fElpasedTime < h2 && g_fMoveSpeed > 2.0)
	{
		g_vEye.x = B_g_vEye.x;
		g_vEye.z = B_g_vEye.z;
	}
}

//-----------------------------------------------------------------------------
// Name: init()
// Desc: 
//-----------------------------------------------------------------------------
void init( void )
{
    g_pD3D = Direct3DCreate9( D3D_SDK_VERSION );

    D3DDISPLAYMODE d3ddm;
    g_pD3D->GetAdapterDisplayMode( D3DADAPTER_DEFAULT, &d3ddm );

    D3DPRESENT_PARAMETERS d3dpp;
    ZeroMemory( &d3dpp, sizeof(d3dpp) );

    d3dpp.Windowed               = TRUE;
    d3dpp.SwapEffect             = D3DSWAPEFFECT_DISCARD;
    d3dpp.BackBufferFormat       = d3ddm.Format;
    d3dpp.EnableAutoDepthStencil = TRUE;
    d3dpp.AutoDepthStencilFormat = D3DFMT_D16;
    d3dpp.PresentationInterval   = D3DPRESENT_INTERVAL_IMMEDIATE;

    g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, g_hWnd,
                          D3DCREATE_SOFTWARE_VERTEXPROCESSING,
                          &d3dpp, &g_pd3dDevice );

	g_pd3dDevice->CreateVertexBuffer( 6*sizeof(Vertex), D3DUSAGE_WRITEONLY, 
                                      Vertex::FVF_Flags, D3DPOOL_DEFAULT, 
                                      &g_pVertexBuffer, NULL );
    void *pVertices = NULL;

    g_pVertexBuffer->Lock( 0, sizeof(g_lineVertices), (void**)&pVertices, 0 );
    memcpy( pVertices, g_lineVertices, sizeof(g_lineVertices) );
    g_pVertexBuffer->Unlock();

    g_pd3dDevice->SetRenderState( D3DRS_LIGHTING, FALSE );
	g_pd3dDevice->SetRenderState( D3DRS_FILLMODE, D3DFILL_WIREFRAME );
	g_pd3dDevice->SetRenderState( D3DRS_CULLMODE, D3DCULL_NONE );

    D3DXMATRIX matProj;
    D3DXMatrixPerspectiveFovLH( &matProj, D3DXToRadian( 45.0f ), 
                                640.0f / 480.0f, 0.1f, 500.0f );
    g_pd3dDevice->SetTransform( D3DTS_PROJECTION, &matProj );

	//-------------------------------------------------------------------------
	
	LPD3DXBUFFER pD3DXMtrlBuffer;

    D3DXLoadMeshFromX("MDL\\mesh1.x", D3DXMESH_SYSTEMMEM, g_pd3dDevice, NULL, &pD3DXMtrlBuffer, NULL, &g_dwNumMaterials, &g_pMesh[0]);
    D3DXLoadMeshFromX("MDL\\mesh2.x", D3DXMESH_SYSTEMMEM, g_pd3dDevice, NULL, &pD3DXMtrlBuffer, NULL, &g_dwNumMaterials, &g_pMesh[1]);
    D3DXLoadMeshFromX("MDL\\mesh3.x", D3DXMESH_SYSTEMMEM, g_pd3dDevice, NULL, &pD3DXMtrlBuffer, NULL, &g_dwNumMaterials, &g_pMesh[2]);
    D3DXLoadMeshFromX("MDL\\mesh4.x", D3DXMESH_SYSTEMMEM, g_pd3dDevice, NULL, &pD3DXMtrlBuffer, NULL, &g_dwNumMaterials, &g_pMesh[3]);

	D3DXCreateTextureFromFile( g_pd3dDevice, "IMG\\mainChar.bmp", &g_pTexture[2] );
	D3DXCreateTextureFromFile( g_pd3dDevice, "IMG\\Robot2.bmp", &g_pTexture[3] );
	D3DXCreateTextureFromFile( g_pd3dDevice, "IMG\\spider2.bmp", &g_pTexture[4] );
	D3DXCreateTextureFromFile( g_pd3dDevice, "IMG\\flyer.bmp", &g_pTexture[5] );

	D3DXCreateTextureFromFile( g_pd3dDevice, "IMG\\XmainChar.bmp", &g_pTexture[6] );
	D3DXCreateTextureFromFile( g_pd3dDevice, "IMG\\XRobot2.bmp", &g_pTexture[7] );
	D3DXCreateTextureFromFile( g_pd3dDevice, "IMG\\Xspider2.bmp", &g_pTexture[8] );
	D3DXCreateTextureFromFile( g_pd3dDevice, "IMG\\Xflyer.bmp", &g_pTexture[9] );

	D3DXCreateFont( g_pd3dDevice, 18, 0, FW_BOLD, 0, FALSE, DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, TEXT("Arial"), &g_pd3dxFont );
	D3DXCreateFont( g_pd3dDevice, 24, 0, FW_BOLD, 0, FALSE, DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, TEXT("Arial"), &g_pd3dxHFont );

	D3DXCreateTextureFromFile( g_pd3dDevice, "IMG\\Title.bmp", &g_pTexture[10] );

	g_vEye.x = 5;
	g_vEye.z = 5;

	for (int i = 0; i < MAX_ACTORS; i++)
	{
		Alist[i] = new Actor();
		Alist[i]->health = -1000;
	}

	M = new map(g_pd3dDevice, "LEV\\level01.lvl");

	NewGame();

    pD3DXMtrlBuffer->Release();
}

void NewLevel( void )
{
	MapLev++;
	char Name[] = "LEV\\Level00.lvl";
	Name[9] = '0' + MapLev / 10;
	Name[10] = '0' + MapLev % 10;

	M = new map(g_pd3dDevice, Name);

	int max = level*8;
	if (max>MAX_ACTORS)max=MAX_ACTORS;
	for (int i = 0; i < max; i++)
	{
		Alist[i]->origin.x = getRandomMinMax(3,59);
		Alist[i]->origin.y = getRandomMinMax(3,59);
		Alist[i]->origin.z = GetExactHeight(M->heightmap, Alist[i]->origin.x, Alist[i]->origin.y) + 1;

		Alist[i]->MDLNUMBER = (int)(i / 7 + level/2) % 8;
		if (Alist[i]->MDLNUMBER > level)Alist[i]->MDLNUMBER = level;

		if (Alist[i]->MDLNUMBER % 4 == 0)//player
		{
			Alist[i]->size.x = 0.35;
			Alist[i]->size.y = 0.35;
			Alist[i]->size.z = 0.75;
			Alist[i]->health = 6 + Alist[i]->MDLNUMBER;
			Alist[i]->reload_mod = 1.5;
			Alist[i]->InitEnemy(2, healPoint, Player->origin, &(Player->health));
		}
		else if (Alist[i]->MDLNUMBER % 4 == 1)//robot
		{
			Alist[i]->size.x = 0.35;
			Alist[i]->size.y = 0.35;
			Alist[i]->size.z = 0.75;
			Alist[i]->health = 4 + Alist[i]->MDLNUMBER/2;
			Alist[i]->reload_mod = 2.2;
			Alist[i]->InitEnemy(1, healPoint, Player->origin, &(Player->health));
		}
		else if (Alist[i]->MDLNUMBER % 4 == 2)//spider
		{
			Alist[i]->size.x = 0.75;
			Alist[i]->size.y = 0.75;
			Alist[i]->size.z = 0.8;
			Alist[i]->health = 10 + Alist[i]->MDLNUMBER*1.5;
			Alist[i]->reload_mod = 1.25;
			Alist[i]->InitEnemy(2, healPoint, Player->origin, &(Player->health));
		}
		if (Alist[i]->MDLNUMBER % 4 == 3)//flyer
		{
			Alist[i]->size.x = 0.1;
			Alist[i]->size.y = 0.1;
			Alist[i]->size.z = 0.1;
			Alist[i]->health = 3 + Alist[i]->MDLNUMBER/3;
			Alist[i]->reload_mod = 1.5 + (Alist[i]->MDLNUMBER*0.5);
			Alist[i]->InitEnemy(3, healPoint, Player->origin, &(Player->health));
		}
		if (b_MultiPlayer) Alist[i]->health = -1000;
	}
}

void NewGame( void )
{
	hp = 100, Max_hp = 100;
	score = 0;
	ammo = 25, Max_ammo = 25;
	level = 1;
	gun = 1, Max_gun = 1;
	loadRate = 4;
	clipLoad = false;

	for (int i = 0; i < MAX_ACTORS; i++)
		Alist[i]->health = -1000;

	NewLevel();
}

//-----------------------------------------------------------------------------
// Name : updateViewMatrix()
// Desc : Builds a view matrix suitable for Direct3D.
//
// Here's what the final matrix should look like:
//
//  |   rx     ux     lx    0 |
//  |   ry     uy     ly    0 |
//  |   rz     uz     lz    0 |
//  | -(r.e) -(u.e) -(l.e)  1 |
//
// Where r = Right vector
//       u = Up vector
//       l = Look vector
//       e = Eye position in world space
//       . = Dot-product operation
//
//-----------------------------------------------------------------------------
void updateViewMatrix( void )
{
	g_vEye.y = 0.0;

	D3DXMATRIX view;
	D3DXMatrixIdentity( &view );

	D3DXVec3Normalize( &g_vLook, &g_vLook );
	D3DXVec3Cross( &g_vRight, &g_vUp, &g_vLook );
	D3DXVec3Normalize( &g_vRight, &g_vRight );
	D3DXVec3Cross( &g_vUp, &g_vLook, &g_vRight );
	D3DXVec3Normalize( &g_vUp, &g_vUp );

	view._11 = g_vRight.x;
    view._12 = g_vUp.x;
    view._13 = g_vLook.x;
	view._14 = 0.0f;

	view._21 = g_vRight.y;
    view._22 = g_vUp.y;
    view._23 = g_vLook.y;
	view._24 = 0.0f;

	view._31 = g_vRight.z;
    view._32 = g_vUp.z;
	view._33 = g_vLook.z;
	view._34 = 0.0f;

	view._41 = -D3DXVec3Dot( &g_vEye, &g_vRight );
	view._42 = -D3DXVec3Dot( &g_vEye, &g_vUp );
	view._43 = -D3DXVec3Dot( &g_vEye, &g_vLook );
	view._44 =  1.0f;

	g_pd3dDevice->SetTransform( D3DTS_VIEW, &view ); 
}

//-----------------------------------------------------------------------------
// Name: shutDown()
// Desc: 
//-----------------------------------------------------------------------------
void shutDown( void )
{
	if( g_pMeshMaterials != NULL )
        delete[] g_pMeshMaterials;

    if( g_pMeshTextures != NULL )
    {
        for( unsigned long i = 0; i < g_dwNumMaterials; ++i )
		{
			if( g_pMeshTextures[i] != NULL )
				g_pMeshTextures[i]->Release();
		}
	
        delete[] g_pMeshTextures;
    }

	if( g_pMesh != NULL )
        g_pMesh[0]->Release(); 

    if( g_pVertexBuffer != NULL )
        g_pVertexBuffer->Release(); 

    if( g_pd3dDevice != NULL )
        g_pd3dDevice->Release();

    if( g_pD3D != NULL )
        g_pD3D->Release();
}

void gameRun( void )
{
	for (int i = 0; i < MAX_ACTORS; i++)
	{
		if (Alist[i] && Alist[i]->health > 0.0)
		{
			Alist[i]->SetPlayerPos(Player->origin);
			Alist[i]->healPoint = healPoint;

			Alist[i]->speed = g_fElpasedTime * Alist[i]->reload_mod;
			Alist[i]->AI();
		}
	}
}

float GetExactHeight(float _Map[64][64], float x, float y)
{
	if (x > 0 && y > 0 && x < 62 && y < 62)
	{
		float dx = x - (int)x, dy = y - (int)y;
		return (1-dx)*(1-dy)*_Map[(int)x][(int)y] + dx*(1-dy)*_Map[(int)x+1][(int)y] + dy*(1-dx)*_Map[(int)x][(int)y+1] + dx*dy*_Map[(int)x+1][(int)y+1];
	}
	return 40;
}

int R_TranslateMonster(D3DXMATRIX *matWorld, D3DXMATRIX *matTranslation, D3DXMATRIX *matScale, D3DXMATRIX *matMesh, Actor *a, float PlayOffs)
{
	D3DXMATRIX matRotation;
	D3DXMatrixRotationYawPitchRoll(&matRotation, 0, D3DXToRadian(-90), 0);

	D3DXMatrixTranslation(matTranslation, (float)(a->origin.x / d_stdUnitScale), (float)(-a->origin.y / d_stdUnitScale) + PlayOffs, (float)(a->origin.z / d_stdUnitScale) -  PlayOffs);
	*matMesh = (*matWorld * *matTranslation * matRotation) * *matScale;
	g_pd3dDevice->SetTransform(D3DTS_WORLD, matMesh);

	g_pd3dDevice->SetTexture(0, g_pTexture[2 + a->MDLNUMBER]);
	g_pMesh[a->MDLNUMBER % 4]->DrawSubset(0);
	return 0;
}

void menu( void )
{
	ShowCursor(true);

    g_pd3dDevice->Clear( 0, NULL, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER, D3DCOLOR_COLORVALUE(0.0f, 0.0f, 0.0, 1.0f), 1.0f, 0 );

    g_pd3dDevice->BeginScene();

	POINT mousePosit;
	GetCursorPos( &mousePosit );
	ScreenToClient( g_hWnd, &mousePosit );

	g_ptLastMousePosit.x = g_ptCurrentMousePosit.x = mousePosit.x;
	g_ptLastMousePosit.y = g_ptCurrentMousePosit.y = mousePosit.y;

	static float h, PlayOffs;

	//------------------------------------------

	D3DXMATRIX matWorld;
	D3DXMatrixTranslation( &matWorld, 0.0f, 0.0f, 2.0f );
	g_pd3dDevice->SetTransform( D3DTS_VIEW, &matWorld ); 
	g_pd3dDevice->SetTransform( D3DTS_WORLD, &matWorld );

	void *pVertices = NULL;//set up the primative
	g_pVertexBuffer->Lock(0, sizeof(tmvlist), (void**)&pVertices, 0);
	memcpy(pVertices, tmvlist, sizeof(tmvlist));
	g_pVertexBuffer->Unlock();
	g_pd3dDevice->SetTexture(0, g_pTexture[10]);
	g_pd3dDevice->SetStreamSource(0, g_pVertexBuffer, 0, sizeof(TMVertex));//create the surface for the texture
	g_pd3dDevice->SetFVF(D3DFVF_TITLEMAPVERTEX);
	g_pd3dDevice->DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 2);

    g_pd3dDevice->SetTexture(0, 0);
	//------------------------------------------

	RECT destRect1, destRect2, destRect3, destRect4;
	SetRect( &destRect1, 100, 280, 0, 0 );
	SetRect( &destRect2, 100, 304, 0, 0 );
	SetRect( &destRect3, 100, 328, 0, 0 );
	SetRect( &destRect4, 100, 352, 0, 0 );

	g_pd3dxHFont->DrawText( NULL,(LPCSTR)"1. New Game", -1, &destRect1, DT_NOCLIP, D3DXCOLOR(1.0f, 1.0f, 1.0f, 1.0f) );
	g_pd3dxHFont->DrawText( NULL,(LPCSTR)"2. Resume", -1, &destRect2, DT_NOCLIP, D3DXCOLOR(1.0f, 1.0f, 1.0f, 1.0f) );
	g_pd3dxHFont->DrawText( NULL,(LPCSTR)"3. Cheat Mode", -1, &destRect3, DT_NOCLIP, D3DXCOLOR(1.0f, 1.0f, 1.0f, 1.0f) );
	g_pd3dxHFont->DrawText( NULL,(LPCSTR)"4. Quit Game", -1, &destRect4, DT_NOCLIP, D3DXCOLOR(1.0f, 1.0f, 1.0f, 1.0f) );

    g_pd3dDevice->EndScene();
    g_pd3dDevice->Present( NULL, NULL, NULL, NULL );

	unsigned char keys[256];
	GetKeyboardState( keys );


	if( keys['1'] & 0x80 || keys['N'] & 0x80 ) 
	{
		d_currentScreen = 0;
		NewGame();
	}
	if( keys['2'] & 0x80 || keys['R'] & 0x80 ) d_currentScreen = 0;
	if( keys['3'] & 0x80 || keys['C'] & 0x80 ) 
	{
		hp = 9999;
		ammo = Max_ammo = 999;
		loadRate = 999;
		Max_gun = 5;
	}
	if( keys['4'] & 0x80 || keys['Q'] & 0x80 ) PostQuitMessage(0);
}

void PauseGame(char *str1)
{
	float r = abs(sin(g_dCurTime*0.0025) * 0.25);
	float g = abs(cos(g_dCurTime*0.0025) * 0.25);
	float b = abs(sin(g_dCurTime*-0.0025) * 0.25);

	ShowCursor(false);

    g_pd3dDevice->Clear( 0, NULL, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER,
                         D3DCOLOR_COLORVALUE(r, g, b, 1.0f), 1.0f, 0 );

    g_pd3dDevice->BeginScene();
	g_pd3dDevice->SetRenderState( D3DRS_FILLMODE, D3DFILL_WIREFRAME );

	//------------------------Grab Mouse--------

	POINT mousePosit;
	GetCursorPos( &mousePosit );
	ScreenToClient( g_hWnd, &mousePosit );
	g_ptLastMousePosit.x = g_ptCurrentMousePosit.x = mousePosit.x;
	g_ptLastMousePosit.y = g_ptCurrentMousePosit.y = mousePosit.y;

	//------------------------------------------

	D3DXMATRIX matWorld, matRotation, matTranslation;
	D3DXMatrixRotationYawPitchRoll(&matRotation, 0, D3DXToRadian(90), 0);
	D3DXMatrixTranslation(&matTranslation, 0.0f, 0.0f, (float)Player->origin.z);
	matWorld = matTranslation * matRotation;
	g_pd3dDevice->SetTransform(D3DTS_WORLD, &matWorld);

	//------------------------------------------

	for (int i = 0; i < 62; i++)
	{
		g_pd3dDevice->SetStreamSource(0, M->g_pTriangleStripGroup_VB[i], 0, sizeof(Vertex));
		g_pd3dDevice->SetFVF(D3D_HEIGHTMAP_FVF_MY_VERTEX);
		g_pd3dDevice->DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 126);
	}

	//------------------------------------------

	D3DXMATRIX matScale;
	D3DXMATRIX matMesh;
	D3DXMatrixScaling( &matScale,  (float)d_stdUnitScale, (float)d_stdUnitScale, (float)d_stdUnitScale);

	//------------------------------------------
	float temp;
	for (int i = 0; i < MAX_ACTORS; i++)
	{
		if (Alist[i] && Alist[i]->health > 0.0)
		{
			R_TranslateMonster(&matWorld, &matTranslation, &matScale, &matMesh, Alist[i], Player->origin.z);
			Alist[i]->lastZ = Alist[i]->origin.z;
			Alist[i]->origin.z = GetExactHeight(M->heightmap, Alist[i]->origin.x, Alist[i]->origin.y)+1.5;
			temp = Alist[i]->origin.z - Alist[i]->lastZ;
			Alist[i]->jumpOffset += -temp;
		}
	}

	g_pd3dDevice->SetTexture( 0, 0 );

	//------------------------------------------

	char str2[] = "press space";
	RECT destRect1, destRect2;
	SetRect( &destRect1, 260, 210, 0, 0 );
	SetRect( &destRect2, 280, 240, 0, 0 );
	g_pd3dxHFont->DrawText( NULL,(LPCSTR)str1, -1, &destRect1, DT_NOCLIP, D3DXCOLOR(1.0f, 1.0f, 1.0f, 1.0f) );
	g_pd3dxFont->DrawText( NULL,(LPCSTR)str2, -1, &destRect2, DT_NOCLIP, D3DXCOLOR(1.0f, 1.0f, 1.0f, 1.0f) );

    g_pd3dDevice->EndScene();
    g_pd3dDevice->Present( NULL, NULL, NULL, NULL );

	unsigned char keys[256];
	GetKeyboardState( keys );
    

		if( keys[VK_SPACE] & 0x80 || keys[VK_RETURN] & 0x80 )
		{
			if (hp <= 0.0) NewGame();
			d_currentScreen = 0;
		}
}

//-----------------------------------------------------------------------------
// Name: render()
// Desc: 
//-----------------------------------------------------------------------------
void render( void )
{
	float h;
	float PlayOffs = h + f_JumpHeight;
	char timeOutput[70]; 
	int minutes, seconds;

	gameTime = gameTime + g_fElpasedTime;
	
	minutes = (int)gameTime / 60;
	seconds = (int)gameTime % 60;
	sprintf(timeOutput, "Time: %d:%d",minutes,seconds);

	ShowCursor(false);

    g_pd3dDevice->Clear( 0, NULL, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER,
                         D3DCOLOR_COLORVALUE(0.0f, 0.0f, 0.0, 1.0f), 1.0f, 0 );

	gameRun();
	getRealTimeUserInput();
	updateViewMatrix();

    g_pd3dDevice->BeginScene();
//----------TEXT OUTPUT-------
    RECT destRect1, destRect2, destRect3, destRect4, destRect5;
    SetRect( &destRect1, 0, 430, 0, 0 );
    SetRect( &destRect2, 000, 410, 0, 0 );
    SetRect( &destRect3, 100, 430, 0, 0 );
    SetRect( &destRect4, 200, 430, 0, 0 );
    SetRect( &destRect5, 0, 0, 0, 0 );
	char str1[64], str2[256], str3[64], str4[64], str5[256], *guns;
	static float TimeCnt = 0.0f;

	TimeCnt = timeGetTime() - (float)g_dStartTime;

	if (clipLoad) {
		ammo += loadRate * g_fElpasedTime;
		if (ammo > Max_ammo) ammo = Max_ammo;
	}

	if (Max_gun == 1.0)	guns = "[1:Pistol]";
	else if(Max_gun == 2.0)	guns = "[1:Pistol 2:MultiRifle]";
	else if(Max_gun == 3.0)	guns = "[1:Pistol 2:MultiRifle 3:HyperBeam]";
	else if(Max_gun == 4.0)	guns = "[1:Pistol 2:MultiRifle 3:HyperBeam 4:BFG 2097]";
	else if(Max_gun == 5.0)	guns = "[1:Pistol 2:MultiRifle 3:HyperBeam 4:BFG 2097 5:ULTRA CANNON]";

	sprintf(str1, "Health %d/%d", (int)hp,  (int)Max_hp);
	sprintf(str2, "Ammo %d/%d Guns %s", (int)ammo, (int)Max_ammo, guns);
	sprintf(str3, "Level %d", (int)level);
	sprintf(str4, "Score %d", (int)score);
	sprintf(str5, "FPS %d\nAdv FPS %d\n%s", (int)(1.0/g_fElpasedTime), (int)(1000.0 * FrameCnt / TimeCnt), timeOutput);

	
	g_pd3dxFont->DrawText( NULL,(LPCSTR)str1, -1, &destRect1, DT_NOCLIP, D3DXCOLOR(1.0f*(100-hp)/100.0f, 0.0f, 1.0f*hp/100.0f, 1.0f) );//100 = hp value
	g_pd3dxFont->DrawText( NULL,(LPCSTR)str2, -1, &destRect2, DT_NOCLIP, D3DXCOLOR(1.0f, 1.0f, 1.0f, 1.0f) );
	g_pd3dxFont->DrawText( NULL,(LPCSTR)str3, -1, &destRect3, DT_NOCLIP, D3DXCOLOR(1.0f, 1.0f, 1.0f, 1.0f) );
	g_pd3dxFont->DrawText( NULL,(LPCSTR)str4, -1, &destRect4, DT_NOCLIP, D3DXCOLOR(1.0f, 1.0f, 1.0f, 1.0f) );
	g_pd3dxFont->DrawText( NULL,(LPCSTR)str5, -1, &destRect5, DT_NOCLIP, D3DXCOLOR(1.0f, 1.0f, 0.5f, 1.0f) );
	//----------------------------
	if (score > level*level)
	{
		level++;
		hp += 10;
		Max_hp += 10;
		ammo = Max_ammo += 2.5;

		if (Max_gun < (int)(level / Max_gun))
			Max_gun = (int)(level / Max_gun);
		loadRate += 1;
		if (snd) {levelup->Stop();levelup->Play(0,0,0);}
	}
	//----------------------------

	D3DXMATRIX matWorld;
	D3DXMatrixScaling( &matWorld, 1.0f, 1.0f, 1.0f );
    g_pd3dDevice->SetTransform( D3DTS_WORLD, &matWorld );

	D3DXMATRIX matRotation, matTranslation;
	D3DXMatrixRotationYawPitchRoll(&matRotation, 0, D3DXToRadian(90), 0);

	if (g_vEye.x > 0 && g_vEye.z > 0 && g_vEye.x < 62 && g_vEye.z < 62)
	{
		float h = GetExactHeight(M->heightmap, g_vEye.x, g_vEye.z);

		Player->origin.x = g_vEye.x;
		Player->origin.y = g_vEye.z;
		Player->origin.z = h + f_JumpHeight;

		D3DXMatrixTranslation(&matTranslation, 0.0f, 0.0f, (float)Player->origin.z);
		PlayOffs = Player->origin.z;
	}
	else
		D3DXMatrixTranslation(&matTranslation, 0.0f, 0.0f, 0.0f);

	matWorld = matTranslation * matRotation;
	g_pd3dDevice->SetTransform(D3DTS_WORLD, &matWorld);

    g_pd3dDevice->SetRenderState( D3DRS_FILLMODE, D3DFILL_SOLID );

	for (int i = 0; i < 62; i++)
	{
		g_pd3dDevice->SetStreamSource(0, M->g_pTriangleStripGroup_VB[i], 0, sizeof(Vertex));
		g_pd3dDevice->SetFVF(D3D_HEIGHTMAP_FVF_MY_VERTEX);
		g_pd3dDevice->DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 126);
	}

	D3DXMATRIX matScale;
	D3DXMATRIX matMesh;
	D3DXMatrixScaling( &matScale,  (float)d_stdUnitScale, (float)d_stdUnitScale, (float)d_stdUnitScale);

//----------------

	int TotalLeft = 0;
	for (int i = 0; i < MAX_ACTORS; i++)
	{
		if (Alist[i] && Alist[i]->health > 0.0)
		{
			TotalLeft++;
			R_TranslateMonster(&matWorld, &matTranslation, &matScale, &matMesh, Alist[i], PlayOffs);
			if (!(Alist[i]->origin.x > 0 && Alist[i]->origin.y > 0 && Alist[i]->origin.x < 62 && Alist[i]->origin.y < 62))
			{
				Alist[i]->origin.x = 32;
				Alist[i]->origin.y = 32;
			}
			Alist[i]->origin.z = GetExactHeight(M->heightmap, Alist[i]->origin.x, Alist[i]->origin.y)+1.5;
			for (int j = 0; j < MAX_MISSILES; j++)
			{
				if (g_particle_Missile[j].f_DieTime <= timeGetTime())
					g_particle_Missile[j].m_vCurPos = D3DXVECTOR3(0,0,0);

				if (abs(Alist[i]->origin.x - Player->origin.x) < Alist[i]->size.x + 1.0 && 
					abs(Alist[i]->origin.y - Player->origin.y) < Alist[i]->size.y + 1.0 && 
					hp > 0.0)
					hp = hp - g_fElpasedTime * 0.5;

				if (abs(Alist[i]->origin.x - g_particle_Missile[j].m_vCurPos.x) < Alist[i]->size.x + 1.0 && 
					abs(Alist[i]->origin.y - g_particle_Missile[j].m_vCurPos.y) < Alist[i]->size.y + 1.0 && 
					abs((-Alist[i]->origin.z) - g_particle_Missile[j].m_vCurPos.z) < Alist[i]->size.z + 1.0 &&
					g_particle_Missile[j].b_Alive)
				{
					g_particle_Missile[j].f_DieTime = timeGetTime() + 500;//1500 = 1.5 seconds
					g_particle_Missile[j].m_vCurVel = D3DXVECTOR3(0,0,0);
					g_particle_Missile[j].b_Alive = false;
					Alist[i]->health = Alist[i]->health - g_particle_Missile[j].f_Damage;
					if (Alist[i]->health <= 0.0)
					{
						score++;
						if (snd) {death->Stop();death->Play(0,0,0);}
					}
				}
				else if (g_particle_Missile[j].m_vCurPos.z >= -GetExactHeight(M->heightmap, g_particle_Missile[j].m_vCurPos.x, g_particle_Missile[j].m_vCurPos.y) - 0.5 &&
					g_particle_Missile[j].b_Alive)
				{
					g_particle_Missile[j].f_DieTime = timeGetTime() + 500;//1500 = 1.5 seconds
					g_particle_Missile[j].m_vCurVel = D3DXVECTOR3(0,0,0);
						g_particle_Missile[j].b_Alive = false;
				}
			}
		}
	}
	if (!TotalLeft) {
		d_currentScreen = 3;
		NewLevel();
	}

	if (b_MultiPlayer)
	{
		R_TranslateMonster(&matWorld, &matTranslation, &matScale, &matMesh, &EnemyPlayers[0], PlayOffs);
		R_TranslateMonster(&matWorld, &matTranslation, &matScale, &matMesh, &EnemyPlayers[1], PlayOffs);
		R_TranslateMonster(&matWorld, &matTranslation, &matScale, &matMesh, &EnemyPlayers[2], PlayOffs);
	}

//--------PARTICALS-----------

	g_pd3dDevice->SetTransform(D3DTS_WORLD, &matWorld);

	updatePointSprites();

	renderPointSprites();

	g_pd3dDevice->SetTexture( 0, 0 );

//------------------------------------

    g_pd3dDevice->EndScene();
    g_pd3dDevice->Present( NULL, NULL, NULL, NULL );

	if (b_MultiPlayer && g_dCurTime - d_LastPacket > 1000.0 / d_NetUpdate)
	{
		d_LastPacket = g_dCurTime;
		Network();
	}
}

void Network ( void )
{
/*
const int MAX_MISSILES = 60;
Particle g_particle_Missile[MAX_MISSILES];

Particle g_particle_Net_Missile[3][MAX_MISSILES];

Actor *Player = new Actor();
Actor EnemyPlayers[3];)

//-----------------------------------

SendToAllPlayers(g_particle_Missile, MAX_MISSILES,3);
SendToAllPlayers(Player, 1,3);

RecieveFromAllPlayers(g_particle_Net_Missile, MAX_MISSILES, 3);
RecieveFromAllPlayers(EnemyPlayers, 1, 3);

*/
}


